<template>
  <div class="auth-wrap h-100">
    <RegistrationInstructionAlert v-if="currentHostname === 'gruzi'" />
    <transition-group
      v-if="currentHostname === 'oboz'"
      name="fadeInBg"
      mode="out-in"
    >
      <div
        v-if="currentBackground === 1"
        :key="1"
        class="background-block body-bg-1"
      />
      <div
        v-else-if="currentBackground === 2"
        :key="2"
        class="background-block body-bg-2"
      />
    </transition-group>
    <div
      v-else-if="currentHostname === 'gruzi'"
      class="background-block body-bg-gruzi"
    />
    <div
      :class="{ '-flex-start': currentHostname === 'gruzi' }"
      class="content-block"
    >
      <div
        v-if="currentHostname === 'oboz'"
        class="svg-wrap"
      >
        <img
          alt="entry_logo"
          src="data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7"
        />
      </div>
      <div
        v-else-if="currentHostname === 'gruzi'"
        class="svg-wrap-gruzi"
      >
        <div class="svg-wrap-gruzi-img"></div>
      </div>
      <div class="action-wrap">
        <div class="buttons-block">
          <ObButton
            label="Вход"
            :to="{ name: 'login' }"
            class="button button-exit"
          />
          <ObButton
            label="Регистрация"
            :to="{ name: 'registration' }"
            class="button button-registration"
            :class="{ 'button-registration-gruzi': currentHostname === 'gruzi' }"
          />
        </div>
      </div>
      <div
        v-if="currentHostname === 'oboz'"
        class="info-block"
      >
        <div class="info-block__item">
          <span>Перевезено за неделю</span>
          <span class="value">199485</span>
          <span>тонн грузов</span>
        </div>
        <div class="info-block__item">
          <span>Зарегистрировано</span>
          <span class="value">9893</span>
          <span>участников</span>
        </div>
        <div class="info-block__item">
          <span>Перевозчиков</span>
          <span class="value">8495</span>
        </div>
        <div class="info-block__item">
          <span>Грузы возят в</span>
          <span class="value">146</span>
          <span>городов</span>
        </div>
      </div>
    </div>
    <div
      v-if="currentHostname === 'gruzi'"
      class="info-message-bottom"
    >
      ООО “Грузи.Ру” 125167, Москва, Ленинградский проспект, д.37, корп. 3, эт.9, пом. XI, ком. 13. ИНН 7729632882, КПП 771401001. Техподдержка:
      <a href="mailto:support@gruzi.ru">support@gruzi.ru</a>
      , +7 (495) 260-17-78
    </div>
  </div>
</template>

<script>
import ObButton from 'common-components/src/obComponents/obButton'
import RegistrationInstructionAlert from '../../components/RegistrationInstructionAlert'
import VueCookie from "vue-cookie";
import api from '@/api'
import { getTokenData } from '@/tokenData'
import {mapMutations} from "vuex";

const BG_CHANGE_TIME = 7000

export default {
  name: 'PageEntry',
  components: {
    ObButton,
    RegistrationInstructionAlert
  },
  data () {
    return {
      currentBackground: 1,
      interval: null
    }
  },
  mounted () {
    this.backgroundTransition()
  },
  beforeDestroy () {
    clearInterval(this.interval)
  },
  created() {
    if(VueCookie.get('auth_token')) {
      this.checkStatus(VueCookie.get('auth_token'), VueCookie.get('refresh_token'))
    }
    sessionStorage.numOpenConnections = 0
  },
  computed: {
    currentHostname() {
      return window.location.host.split('gruzi').length > 1 ? 'gruzi': 'oboz'
    },
  },
  methods: {
    ...mapMutations({
      setTokenData: 'user/setTokenData'
    }),
    backgroundTransition () {
      this.interval = setInterval(() => {
        this.currentBackground = this.currentBackground === 1 ? 2 : 1
      }, BG_CHANGE_TIME)
    },
    async checkStatus (token, refreshToken) {
      if (!token) {
        this.showError()
      } else {
        VueCookie.set('auth_token', token)
        VueCookie.set('refresh_token', refreshToken)
        localStorage.setItem('refresh_auth_token', token);
        this.setTokenData()
        let userInfo = null
        const response = await api.registration.auth.status()
        const status = response.participantStatus;
        const draftOrderId = response.draftOrderId;

        if (status !== 'NEW') {
          userInfo = await api.registration.auth.getUserInfo()
        }
        let isTenderRoles = userInfo && userInfo.roles && userInfo.roles.length && Boolean(userInfo.roles.find(item => ['организатор тендера', 'участник тендера'].includes(item.name && item.name.toLowerCase())))

        this.$nextTick(async () => {
          const { contractor_role_code } = { ...getTokenData() }

          if (status === 'NEW') {
            if (draftOrderId) {
              await api.registration.accreditation.setUserActivitiesAndPersonalData({ draftOrderId })
              const data = await api.registration.auth.refresh({ token: refreshToken });
              VueCookie.set('auth_token', data.token);
              VueCookie.set('refresh_token', data.refreshToken);
              localStorage.setItem('refresh_auth_token', token);
              await this.fetchMenu()
              this.$router.replace(`order-drafts-item/${draftOrderId}`)
            } else {
              this.$router.replace({ name: 'registration' });
            }
          } else {
            if(isTenderRoles) {
              this.$router.replace({ name: 'tenders__tenders' })
            } else if (contractor_role_code  === 'clicar') {
              this.$router.replace({ name: 'order__performerer' })
            } else if (contractor_role_code  === 'carrier') {
              this.$router.replace({ name: 'requests__search-orders' })
            } else if (draftOrderId) {
              this.$router.replace(`order-drafts-item/${draftOrderId}`)
            } else {
              this.$router.replace({ name: 'settings__sb_settings__task_monitor' })
            }

          }
        })
      }
    }
  },
  metaInfo() {
    return {
      meta: [
        { name: 'yandex', content: 'noindex, nofollow' }
      ]
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .auth-wrap {
    position: relative;
    display: flex;
    flex-direction: column;
    width: 100%;
    height: 100%;
    overflow: hidden;
  }

  .content-block {
    height: 100%;
    width: 100%;
    padding: 100px;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    position: relative;

    &.-flex-start {
      justify-content: flex-start;
    }
  }

  .background-block {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    .body-bg-1, .body-bg-2 {
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
    }

    &.body-bg-gruzi {
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      background: url('~@/assets/images/gruzi_bg.png') center no-repeat;
      background-size: cover;
    }
  }

  .logo {
    fill: transparent;
    stroke: $style-white;
    stroke-width: 1;
    width: 100%;
    height: 250px;
  }

  .action-wrap{
    display: flex;
    flex-direction: column;
  }

  .action{
    @include font-mixin(30px, 38px, 400, $style-white, 0.4px);
  }

  .slogan-wrap{
    display: flex;
    flex-direction: column;
    margin-top: 40px;
  }

  .slogan {
    @include font-mixin(45px, 38px, 700, $style-white, 0.4px);
    margin-bottom: 20px;
  }

  .buttons-block {
    display: flex;
    align-items: center;
    flex-wrap: wrap;
    margin: 20px 0;
    button {
      width: 200px;
      margin-right: 30px;
      color: #fff!important;
    }
    .button-exit {
      background-color: $blue-700!important;
    }

    .button-registration-gruzi {
      background-color: $white;
      color: $color-blue-navy-blue !important;
      border: 2px solid $color-blue-navy-blue;

      &:hover {
        background-color: $white;
      }
    }
  }

  .info-block {
    display: flex;
    justify-content: space-between;
    align-items: flex-start;
    &__item {
      width: 209px;
      max-width: 23%;
      span {
        @include font-mixin(16px, 24px, 400, $style-white, 0.4px);
        display: block;

        &.value {
          font-size: 56px;
          line-height: 66px;
        }
      }
    }
  }

  .fadeInBg-enter, .fadeInBg-leave-to {
    opacity: 0;
  }
  .fadeInBg-enter-active, .fadeInBg-leave-active {
    transition: opacity 2s ease-in-out;
  }

  .svg-wrap-gruzi {
    margin-bottom: 78px;
  }

  .svg-wrap-gruzi-img {
    width: 305px;
    height: 94px;
    overflow: hidden;
    background-image: url('~@/static/img/logo_gruzi.svg');
    background-size: cover;
  }

  .info-message-bottom {
    @include font-mixin(12px, 12px, 400, $color-text-base, 0.4px);
    position: fixed;
    width: 100%;
    left: 0;
    bottom: 0;
    background-color: rgb(224,245,255);
    padding: 6px 20px;
    z-index: 999;

    a {
      color: inherit;
      text-decoration: none;
    }
  }
</style>
